import os
import sys
# change path later based on location of Results folder
sys.path.append('/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration')
path1=sys.path[-1]
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import matplotlib.patches as mpatches
from Analysis.Results import common_functions as cf
from Analysis.Results.Result_1 import reading_n_processing as rnp
from Analysis.Results.Result_1 import Buoy_Direct_TA as bdt
from Analysis.Results.Result_1 import Model_Buoy_TA as mbt
import xarray as xr
import importlib
importlib.reload(cf)


folder='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Buoy_data_excel/procesd_buoy_loc_data_Lars/'
Bnum='03'
dt=15 #mins
fig_path='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Results/Result_1/Figures/'
sampling_period=dt/60 #hours
TC=cf.Tidal_const()
TC_value=np.fromiter(TC.values(),dtype=float)
TCname=TCname=np.array(list(TC.keys()))
(Xib,Yib,Uibt,Vibt,Tib)=rnp.get_buoy_tidal_data(folder,Bnum)

fitting_param_file='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Results/Result_1/Fitting_Method_Results/BUOY_'+Bnum+'_opt.csv'
fitting_data=pd.read_csv(fitting_param_file)
nparams=12
fitting_param_u=fitting_data['U_data'].values[:nparams*2]
fitting_param_v=fitting_data['V_data'].values[:nparams*2]
def compute_fitting_velocities(fitting_param,Xib,Yib,Tib,TCname):
    Amp_params=fitting_param[0:4*3].reshape(4,3)
    phi_params=fitting_param[4*3:].reshape(4,3)
    U_ts=bdt.computing_buoy_estimated_velocity(Xib,Yib,Tib,Amp_params,phi_params,TCname)
    return(U_ts,Amp_params,phi_params)
U_fitting,U_Amp_params,U_phi_params=compute_fitting_velocities(fitting_param_u,Xib,Yib,Tib,TCname)
V_fititng,V_Amp_params,V_phi_params=compute_fitting_velocities(fitting_param_v,Xib,Yib,Tib,TCname)

#save the velocities  in a file
vel_df=pd.DataFrame.from_dict({'Time':Tib.values,'U':U_fitting,'V':V_fititng})
vel_df.to_csv('/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Results/Result_1/Fitting_Method_Results/BUOY_'+Bnum+'_velocities.csv')
