#%%
#importing the required packages
import os
import sys
sys.path.append('/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration')
path1=sys.path[-1]
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import cartopy.crs as ccrs
import cartopy.feature as cpf
from Data_Processing.Buoy_processing import reading_plotting as bscripts
from Analysis.Results.Result_1 import reading_n_processing as rnp
import matplotlib.transforms as transforms
from cartopy.mpl.gridliner import LONGITUDE_FORMATTER, LATITUDE_FORMATTER
import datetime
import hatyan
import xarray as xr
import Analysis.GTSM_Analysis.interpolating_TC as itc
import Analysis.tidal_ellipse as tp
#%%

location='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Results/Result_1/Model_Buoy_Method_Results/'
b03_opt=location+'BUOY_03_Optimal.csv'
b16_opt=location+'BUOY_16_Optimal.csv'
b03_opt_data=pd.read_csv(b03_opt)
b16_opt_data=pd.read_csv(b16_opt)
b03_gtsm=location+'BUOY_03_Default.csv'
b16_gtsm=location+'BUOY_16_Default.csv'
b03_gtsm_data=pd.read_csv(b03_gtsm)
b16_gtsm_data=pd.read_csv(b16_gtsm)

#opt data
b03_opt_U=b03_opt_data['Umod'].values
b03_opt_V=b03_opt_data['Vmod'].values
b16_opt_U=b16_opt_data['Umod'].values
b16_opt_V=b16_opt_data['Vmod'].values
#default data
b03_gtsm_U=b03_gtsm_data['Umod'].values
b03_gtsm_V=b03_gtsm_data['Vmod'].values
#below are same as the default data
b16_gtsm_U=b16_gtsm_data['Umod'].values
b16_gtsm_V=b16_gtsm_data['Vmod'].values

##buoy derived fitting
bdf_location='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Results/Result_1/Fitting_Method_Results/'
b03_bdf=bdf_location+'BUOY_03_Optimal.csv'
b16_bdf=bdf_location+'BUOY_16_Optimal.csv'
b03_bdf_data=pd.read_csv(b03_bdf)
b16_bdf_data=pd.read_csv(b16_bdf)
b03_bdf_U=b03_bdf_data['Umod'].values
b03_bdf_V=b03_bdf_data['Vmod'].values
b16_bdf_U=b16_bdf_data['Umod'].values
b16_bdf_V=b16_bdf_data['Vmod'].values

Tib=b03_opt_data['Tib'].values
# %%
##computing the tidal amplitudes and phases and the tidal ellipse parameters
#


#%%
def get_tidal_parameters(U,V):
    timeseries=pd.to_datetime(Tib)
    const_list=['M2','S2','O1','K1']
    useries=pd.DataFrame(U,index=timeseries,columns=['values'])
    vseries=pd.DataFrame(V,index=timeseries,columns=['values'])
    comp_x=hatyan.analysis(ts=useries,const_list=const_list,nodalfactors=True)
    comp_y=hatyan.analysis(ts=vseries,const_list=const_list,nodalfactors=True)
    #tidal ellipse parameters
    A_U_param=np.array([comp_x.A.M2,comp_x.A.S2,comp_x.A.O1,comp_x.A.K1])
    phi_deg_U_param=np.array([comp_x.phi_deg.M2,comp_x.phi_deg.S2,comp_x.phi_deg.O1,comp_x.phi_deg.K1])
    A_V_param=np.array([comp_y.A.M2,comp_y.A.S2,comp_y.A.O1,comp_y.A.K1])
    phi_deg_V_param=np.array([comp_y.phi_deg.M2,comp_y.phi_deg.S2,comp_y.phi_deg.O1,comp_y.phi_deg.K1])
    SEMAi,ECCi,INCi,PHAi,wi=tp.ap2ep(A_U_param,phi_deg_U_param,A_V_param,phi_deg_V_param)    
    return(A_U_param,phi_deg_U_param,A_V_param,phi_deg_V_param,SEMAi,ECCi,INCi,PHAi)

#making a dataframe as per the format the the index is ['M2','S2','O1','K1'] and the columns are ['A_U','phi_deg_U','A_V','phi_deg_V','SEMAi','ECCi','INCi','PHAi']
# for each of the estimates
def create_csv(A_U_param,phi_deg_U_param,A_V_param,phi_deg_V_param,SEMAi,ECCi,INCi,PHAi,fname):
    df=pd.DataFrame({'A_U':A_U_param,'phi_deg_U':phi_deg_U_param,'A_V':A_V_param,'phi_deg_V':phi_deg_V_param,'SEMAi':SEMAi,'ECCi':ECCi,'INCi':INCi,'PHAi':PHAi},index=['M2','S2','O1','K1'])
    df.to_csv(fname)
#%%
(A_U_param,phi_deg_U_param,A_V_param,phi_deg_V_param,SEMAi,ECCi,INCi,PHAi)=get_tidal_parameters(b03_opt_U,b03_opt_V)
fname='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Results/Result_1/Model_Buoy_Method_Results/BUOY_03_Optimal_tidal_parameters.csv'
create_csv(A_U_param,phi_deg_U_param,A_V_param,phi_deg_V_param,SEMAi,ECCi,INCi,PHAi,fname)
#%%
(A_U_param,phi_deg_U_param,A_V_param,phi_deg_V_param,SEMAi,ECCi,INCi,PHAi)=get_tidal_parameters(b16_opt_U,b16_opt_V)
fname='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Results/Result_1/Model_Buoy_Method_Results/BUOY_16_Optimal_tidal_parameters.csv'
create_csv(A_U_param,phi_deg_U_param,A_V_param,phi_deg_V_param,SEMAi,ECCi,INCi,PHAi,fname)
# %%
(A_U_param,phi_deg_U_param,A_V_param,phi_deg_V_param,SEMAi,ECCi,INCi,PHAi)=get_tidal_parameters(b03_gtsm_U,b03_gtsm_V)
fname='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Results/Result_1/Model_Buoy_Method_Results/BUOY_03_Default_tidal_parameters.csv'
create_csv(A_U_param,phi_deg_U_param,A_V_param,phi_deg_V_param,SEMAi,ECCi,INCi,PHAi,fname)
# %%
(A_U_param,phi_deg_U_param,A_V_param,phi_deg_V_param,SEMAi,ECCi,INCi,PHAi)=get_tidal_parameters(b16_gtsm_U,b16_gtsm_V)
fname='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Results/Result_1/Model_Buoy_Method_Results/BUOY_16_Default_tidal_parameters.csv'
create_csv(A_U_param,phi_deg_U_param,A_V_param,phi_deg_V_param,SEMAi,ECCi,INCi,PHAi,fname)
# %%
(A_U_param,phi_deg_U_param,A_V_param,phi_deg_V_param,SEMAi,ECCi,INCi,PHAi)=get_tidal_parameters(b03_bdf_U,b03_bdf_V)
fname='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Results/Result_1/Fitting_Method_Results/BUOY_03_Optimal_tidal_parameters.csv'
create_csv(A_U_param,phi_deg_U_param,A_V_param,phi_deg_V_param,SEMAi,ECCi,INCi,PHAi,fname)
# %%
(A_U_param,phi_deg_U_param,A_V_param,phi_deg_V_param,SEMAi,ECCi,INCi,PHAi)=get_tidal_parameters(b16_bdf_U,b16_bdf_V)
fname='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Results/Result_1/Fitting_Method_Results/BUOY_16_Optimal_tidal_parameters.csv'
create_csv(A_U_param,phi_deg_U_param,A_V_param,phi_deg_V_param,SEMAi,ECCi,INCi,PHAi,fname)
# %%
