#%%
import os
import sys
# change path later based on location of Results folder
sys.path.append('/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration')
path1=sys.path[-1]
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import matplotlib.patches as mpatches
from Analysis.Results import common_functions as cf
from Analysis.Results.Result_1 import reading_n_processing as rnp
from Analysis.Results.Result_1 import Buoy_Direct_TA as bdt
from Analysis.Results.Result_1 import Model_Buoy_TA as mbt
import xarray as xr
import importlib
import utide
importlib.reload(cf)
#matplot lib rcparams make all fonts bold in the plot
plt.rcParams["font.weight"] = "bold"
#make all fonts of size 14
plt.rcParams["font.size"] = 14
import Analysis.tidal_ellipse as tp
#%%
#reading the buoy data from Lars
folder='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Buoy_data_excel/procesd_buoy_loc_data_Lars/'
Bnum='03'
dt=15 #mins
fig_path='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Results/Result_1/Figures/'
sampling_period=dt/60 #hours
TC=cf.Tidal_const()
TC_value=np.fromiter(TC.values(),dtype=float)
TCname=TCname=np.array(list(TC.keys()))
(Xib,Yib,Uibt,Vibt,Tib)=rnp.get_buoy_tidal_data(folder,Bnum)
# Calculate the median locations for the buoy
xb = np.median(Xib)
yb = np.median(Yib)

print(f"Buoy median location: xb = {xb}, yb = {yb}")
TCname=['M2','S2','O1','K1']
# %%
from utide import solve

u_coef= solve(
    t=Tib,u=Uibt,
    lat=yb,
    nodal=False,
    trend=False,
    method='ols',
    conf_int='linear',
    Rayleigh_min=0.95,constit=['M2','S2','O1','K1']
)


# %%
print(u_coef['name'])
indices = [np.where(u_coef['name'] == name)[0][0] for name in TCname]
print(indices)
u_amp=u_coef['A'][indices]
u_pha=u_coef['g'][indices]

v_coef= solve(
    t=Tib,u=Vibt,
    lat=yb,
    nodal=False,
    trend=False,
    method='ols',
    conf_int='linear',
    Rayleigh_min=0.95,constit=['M2','S2','O1','K1']
)

print(v_coef['name'])
v_indices = [np.where(v_coef['name'] == name)[0][0] for name in TCname]
print(v_indices)
v_amp=v_coef['A'][v_indices]
v_pha=v_coef['g'][v_indices]

SEMAi, ECCi, INCi, PHAi, wi = tp.ap2ep(u_amp, u_pha, v_amp, v_pha)

def create_csv(A_U_param, phi_deg_U_param, A_V_param, phi_deg_V_param, SEMAi, ECCi, INCi, PHAi, fname):
    df = pd.DataFrame({
        'A_U': A_U_param,
        'phi_deg_U': phi_deg_U_param,
        'A_V': A_V_param,
        'phi_deg_V': phi_deg_V_param,
        'SEMAi': SEMAi,
        'ECCi': ECCi,
        'INCi': INCi,
        'PHAi': PHAi
    }, index=['M2', 'S2', 'O1', 'K1'])
    df.to_csv(fname)
folder='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Results/Result_1/Model_Buoy_Method_Results'
create_csv(u_amp, u_pha, v_amp, v_pha, SEMAi, ECCi, INCi, PHAi, os.path.join(folder, f'BUOY_{Bnum}_ttide.csv'))
# %%
