
#%%
import os
import sys
# change path later based on location of Results folder
sys.path.append('/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration')
path1=sys.path[-1]
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import matplotlib.patches as mpatches
from Analysis.Results import common_functions as cf
from Analysis.Results.Result_1 import reading_n_processing as rnp
from Analysis.Results.Result_1 import Buoy_Direct_TA as bdt
from Analysis.Results.Result_1 import Model_Buoy_TA as mbt
import Analysis.Barotropic_Study.compute_linearised_residuals as clr
import xarray as xr
import importlib
import utide
importlib.reload(cf)
#matplot lib rcparams make all fonts bold in the plot
plt.rcParams["font.weight"] = "bold"
#make all fonts of size 14
plt.rcParams["font.size"] = 14
import Analysis.tidal_ellipse as tp
importlib.reload(clr)
#%%
syn_buoy_data_location='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Baroclinic_Model_TOPAZ/model_buoy_data/synthetic_data/'
syn_buoy_df=pd.read_csv(syn_buoy_data_location+'October_synthetic_buoy_data_15min.csv',index_col=0)
syn_buoy_lon=syn_buoy_df['Lon'].values
syn_buoy_lat=syn_buoy_df['Lat'].values
#start date and month
sdate='2018-10-28'
edate='2018-11-12'
#buoy testing data:
print(np.median(syn_buoy_lon),np.median(syn_buoy_lat))
syn_buoy_loc=[np.median(syn_buoy_lon),np.median(syn_buoy_lat)]


#%%

buoy_data_df=syn_buoy_df

buoy_lon=buoy_data_df['Lon'].values;buoy_lat=buoy_data_df['Lat'].values

#%%

buoy_loc=[np.median(buoy_lon),np.median(buoy_lat)]
ts_vec=buoy_data_df['time']
# Calculate the median locations for the buoy
xb = buoy_loc[0]
yb = buoy_loc[1]
#%%
Ub=buoy_data_df['Uvel'].values
Vb=buoy_data_df['Vvel'].values
#%%
sampling_period=15/60
buoy_data_df['Ub']=Ub
buoy_data_df['Vb']=Vb
Ubres,Vbres=clr.get_buoy_velocities(buoy_data_df,sampling_period)
U=buoy_data_df.Ub.values
V=buoy_data_df.Vb.values
print(f"Buoy median location: xb = {xb}, yb = {yb}")
TCname=['M2','S2','O1','K1']

# %%
from utide import solve

u_coef= solve(
    t=ts_vec,u=Ubres,
    lat=yb,nodal=True,
    trend=False,
    method='ols',
    conf_int='linear',
    Rayleigh_min=0.95
)


# %%
print(u_coef['name'])
indices = [np.where(u_coef['name'] == name)[0][0] for name in TCname]
print(indices)
u_amp=u_coef['A'][indices]
u_pha=u_coef['g'][indices]

v_coef= solve(
    t=ts_vec,u=Vbres,
    lat=yb,
    nodal=True,
    trend=False,
    method='ols',
    conf_int='linear',
    Rayleigh_min=0.95
)

print(v_coef['name'])
v_indices = [np.where(v_coef['name'] == name)[0][0] for name in TCname]
print(v_indices)
v_amp=v_coef['A'][v_indices]
v_pha=v_coef['g'][v_indices]

SEMAi, ECCi, INCi, PHAi, wi = tp.ap2ep(u_amp, u_pha, v_amp, v_pha)

def create_csv(A_U_param, phi_deg_U_param, A_V_param, phi_deg_V_param, SEMAi, ECCi, INCi, PHAi, fname):
    df = pd.DataFrame({
        'A_U': A_U_param,
        'phi_deg_U': phi_deg_U_param,
        'A_V': A_V_param,
        'phi_deg_V': phi_deg_V_param,
        'SEMAi': SEMAi,
        'ECCi': ECCi,
        'INCi': INCi,
        'PHAi': PHAi
    }, index=['M2', 'S2', 'O1', 'K1'])
    df.to_csv(fname)
folder='/u/vasulkar/p_emodnet_amey/Tidal_ellipse_calibration/Analysis/Results/Result_5_baroclinic/'
create_csv(u_amp, u_pha, v_amp, v_pha, SEMAi, ECCi, INCi, PHAi, os.path.join(folder, f'syn_buoy.csv'))
# %%
